    

    #==================================================   
    # Functions: rGLM,one.rGLM.test,Test.rGLM
    #           modify on 1-6-2009  
    #                1 rGLM()
    #==================================================   



   `rGLM`<-function(form, haplos.list, baseline = "missing",family = binomial,
                  freq = NULL, maxit = 50, tol = 0.001, start = NULL, lambda=0,
                  trace = FALSE) {   
  
       
       haplos.names <- names(haplos.list$initFreq)
       fmla <- as.formula(form)  
       if (!is.null(freq)) {
          names(freq) <- haplos.names
          }  else {
          freq <- haplos.list$initFreq
         }
       if (!is.na(all.vars(fmla)[2]) && all.vars(fmla)[2] == "." && (baseline == "missing")) {
          baseline <- haplos.names[which.max(freq)] 
          }
      
       column.subset <- colnames(haplos.list$haploDM) != baseline
       hdat <- cbind(haplos.list$nonHaploDM, haplos.list$haploDM[,column.subset])
       colnames(hdat) <- c(colnames(haplos.list$nonHaploDM), colnames(haplos.list$haploDM[,column.subset]))
       ID <- haplos.list$ID
       N <- sum(haplos.list$wt)
       wts <- haplos.list$wt
       haplos <- haplos.list$haploDM           
       haploMat <- haplos.list$haploMat       
       allHaps <- c(haploMat[, 1], haploMat[, 2])  
    
      
       covariate<-all.vars(fmla) 
       y <- as.numeric(hdat[,covariate[1]])
       x <- data.matrix(hdat[,covariate[-1]])        
       regr <- glmpath(x, y, family=family,weight = wts,standardize=FALSE,min.lambda=0) 
       beta <- regr$b.corrector[which.min(regr$lambda),] 
       beta <- beta[c("Intercept",colnames(x))] 
       fits <- 1/(1+exp(-(beta[1]+x%*%beta[-1])))[,1] 
       response<-y
       
    
       if (trace) {cat("*** Begin rGLM function() ***","\n")
                   format(form,"\n") 
                   cat(paste("dim(x)=",dim(x)[1],",",dim(x)[2],", and x are",sep=" "),"\n") 
                   cat(paste(colnames(x),collapse="   "),"\n","\n")
                   cat(paste("Under the convergence criterion of ",tol,":"),"\n")}


       loglik<-NA
       betadiff <- 1
       it <- 0 
       while ((it < maxit) && (betadiff > tol)) { 
          it <- it + 1
          haplo.probs <- rep(1, nrow(haplos)) + isMultiHetero(haplos.list)  
          haplo.probs <- haplo.probs * freq[haploMat[, 1]] * freq[haploMat[,2]]
          phi <-  regr$converged   
        
          num.prob <- (fits^y * (1-fits)^(1-y)) * as.numeric(haplo.probs) 
          wts<-as.numeric(getWts(num.prob,ID))  
          regr <- glmpath(x, y, family=family,weight = wts,standardize=FALSE,min.lambda=lambda)  
         
        
          betaNew <- regr$b.corrector[which.min(regr$lambda),] 
          betaNew <- betaNew[c("Intercept",colnames(x))] 
          fits <- 1/(1+exp(-(betaNew[1]+x%*%betaNew[-1])))[,1]   
    
     
          betadiff <- max(max(abs(beta - betaNew), na.rm = TRUE), 
                          max(abs(beta - betaNew)/(0.1 + abs(betaNew)), na.rm = TRUE))
          beta <- betaNew

          freq <- tapply(c(wts, wts), allHaps, sum)/(2 * N)
          if (trace) cat("iteration", it, ": value of convergence criterion =", betadiff, "\n")
          
        }
      

        if (betadiff > tol) { 
        ans <- list(converged = FALSE) 
        class(ans) <- "rGLM" 
        }
        if (betadiff <= tol){ 
        freq <- as.matrix(freq)
        EMresults <- list(beta = beta, gamma = freq, fits = fits, 
        wts = wts, ID = ID, glm.final.fit = regr,response = response)
        names(haplos.list)[names(haplos.list) == "freq"] <- "gamma"
        names(EMresults)[names(EMresults) == "freq"] <- "gamma"  
        loglik <- loglik(haplos.list, EMresults) 
    
        ans <- list(it = it, beta = beta, freq = freq, fits = fits, 
               wts = wts, ID = ID, response = response, converged = TRUE, 
               model = fmla, loglik = loglik)
            
        class(ans) <- "rGLM"
        }
        if (trace)   cat("*** Finish this rGLM()! ***","\n")  
        return(ans) 
      }


 
   #=====================================================================| 
   #                             subroutines                             |
   #                                                                     |
   #=====================================================================| 
  
     `isMultiHetero`<-function(haplos.list){ 
             haplos <- haplos.list$haploDM 
             m<-2-0.5*rowMeans(haplos^2)*ncol(haplos)  
             return(m)
             }

     `pYgivenX`<-function(response, fits){  
           prob.y<-fits^response * (1-fits)^(1-response) 
           return(prob.y)
          }

     `getWts`<-function(num.prob,ID){
          den<-NULL
          for (i in 1:length(ID)) 
          den[i]<-sum(num.prob[ID==ID[i]])
          Wts<-num.prob/den
          return(Wts)
         }

  
     `loglik`<-function(haplos.list, EMresults){ 
        freq<-EMresults$gamma[,1]
        haplos <- haplos.list$haploDM        
        haploMat <- haplos.list$haploMat   
        haplo.probs <- rep(1, nrow(haplos)) + isMultiHetero(haplos.list) 
        haplo.probs <- haplo.probs * freq[haploMat[, 1]] * freq[haploMat[,2]]   
        
        loglik<- (EMresults$fits )^(EMresults$response ) *
                 (1-EMresults$fits )^(1-EMresults$response ) * 
                 (haplo.probs)  
        
        outloglik<-0; sum<-loglik[1];  
        for (i in 1:length(haplos.list$ID)){
        id.next<-ifelse(i<length(haplos.list$ID),haplos.list$ID[i+1],Inf)
        if (id.next==haplos.list$ID[i])
            sum<-sum+loglik[i+1] 
        if (id.next!=haplos.list$ID[i]){
            outloglik<-outloglik+log(sum)
            sum<-loglik[i+1]  } 
        }  
       
       return(as.numeric(outloglik))
      }
 
    
     `find.formula`<-function(preDat,pooling.tol=0){ 
           u1<-names(preDat$init)         
           u2<-as.numeric(preDat$init)     
           u3<-order(u2,decreasing = TRUE)        
           e2<-length(preDat$init)       
           e3<-0
           covar<-NULL
           for (i in 1:e2)  {if (u2[i] >=pooling.tol && !i==u3[1]) {e3<-e3+1; covar[e3]<-u1[i]} }  
           if ( !(preDat$pooledHaplo[1]=="no pooled haplos")) {e3<-e3+1; covar[e3]<-"pooled"}
           if (e3==0 & length(u1)>=2) covar<-u1[u3[2]]  

           if (ncol(preDat$nonHaploDM)>1) covar<-c(names(preDat$nonHaploDM)[-1],covar)
           vname<-paste(names(preDat$nonHaploDM)[1], paste(covar, collapse= "+"),sep="~")                  
           fmla <- as.formula(vname)  
         ans<-list(fmla=fmla,covariate=covar)
         return(ans)
         }


 
 
       
    #================================================================================
    #        2:  one.rGLM.test() 
    #            Calculate LRT=2(L_H1-L_H0) by employing rGLM() twice.
    #================================================================================ 


    `one.rGLM.test`<-function(nonSNPcolumns,hypoDat, family=binomial, allelic=TRUE, 
                    pooling.tol = 0.05, maxit=200, tol=0.001, lambda=0, trace=FALSE){  
       
        
        if (trace) cat("*** Begin one.rGLM.test() for test. ***","\n")     
        if (length(lambda)>1) stop("one.rGLM.test needs a fixed lambda")

        hypoDat.y<-array(0,dim=c(nrow(hypoDat),nonSNPcolumns))
        for (j in 1:nonSNPcolumns) hypoDat.y[,j]<-as.numeric(hypoDat[,j])  
        hypoDat.x<-hypoDat[,-(1:nonSNPcolumns)] 
        hypoGeno<-cbind(hypoDat.y,data.frame(hypoDat.x)) 
        colnames(hypoGeno)<-colnames(hypoDat)  
      
        numSNPs<-ifelse(allelic,ncol(hypoDat.x)/2,ncol(hypoDat.x))  
        if (trace) cat(paste("numSNPs=",numSNPs),"\n")                
        preDat<-try(pre.hapassoc(hypoGeno,numSNPs=numSNPs,maxMissingGenos=as.integer(numSNPs/2),
                 allelic=allelic,pooling.tol = pooling.tol,zero.tol = 1/(2 * nrow(hypoGeno) * 10), 
                 verbose=trace))  
        if (trace) cat("----Got preDat----","\n") 
    
        if (is.character(preDat) | !is.list(preDat)) {
        if (trace) cat("Can not pass pre.hapassoc in one.rGLM.test function")
        ans<-list(data=hypoGeno,pre.hapassoc.data=NA,LRTstat=NA,
                  regrH1=NA,regrH0=NA,H1.converged=FALSE,
                  H0.converged=FALSE,na.resason="na.pre.hapassoc") } else {
      
        fma<-find.formula(preDat,pooling.tol=pooling.tol)   
        regr2<-try(rGLM(form=fma$fmla,haplos.list=preDat,maxit=maxit,lambda=lambda,trace=trace))  
        if (trace) cat("-----Finish call rGLM in one.rGLM.test under H1","\n")

        regr1<-try(hapassoc(affected~1.,preDat,tol=tol,maxit = maxit,family=family))  
        if  (!(is.list(regr1) && regr1$converged))
        regr1<-try(rGLM(form=affected~1., haplos.list=preDat,
                    maxit=maxit,lambda=0,trace=trace))  
        if (trace) cat("-----Finish call rGLM in one.rGLM.test under H0","\n")


        H0.converged<-ifelse( (is.list(regr1) && regr1$converged), TRUE,FALSE)
        H1.converged<-ifelse( (is.list(regr2) && regr2$converged), TRUE,FALSE)
       
        if (H0.converged & H1.converged) {
        LRTstat<-2*(regr2$loglik-regr1$loglik)
        na.reason<-"conv"} else {
        LRTstat<-NA
        na.reason<-paste("unconv",ifelse(H1.converged,"","H1"),ifelse(H0.converged,"","H0"),sep=".")}

        loglik<-ifelse(H1.converged,regr2$loglik,NA)
        ans<-list(data=hypoGeno,pre.hapassoc.data=preDat,LRTstat=LRTstat,
                  regrH1=regr2,regrH0=regr1,H1.converged=H1.converged,
                  H0.converged=H0.converged,na.resason=na.reason,lambda=lambda,
                  loglik=loglik)        
        }
       if (trace) cat(c("----Finish one.rGLM.test(): LRT,H1,H0=",round(ans$LRTstat,3),ans$H1.converged,ans$H0.converged,"\n"))
       return(ans)
     }




    #================================================================================
    #              3:  apply.rGLM.test() 
    #      Apply permutation and choose lambda by AIC
    #================================================================================ 

       `apply.rGLM.test`<-function(nonSNPcolumns,hypoDat, family=binomial, allelic=TRUE, pooling.tol = 0.05,
                            maxit=200,tol=0.001,lambda,Bpermu=100,trace=FALSE,hightrace=FALSE){  
          
           if (trace) {cat("----Begin apply.rGLM.test() for permutation test.----","\n") 
                       cat(paste(c("lambda=",lambda),sep="      "),"\n")}
          
          
           permu.aic.lambda<-NA
           permu.LRTstat<-NA
           permu.pvalue<-NA 
           permu.na<-NA  
           aic.true.rGLM<-NA 
           aic.lambda<-NA 
           obs.beta.trace<-NA  

           if (trace) {cat("B  th permutation:      lambda       loglik_H1        loglik_H0:","\n") 
                       cat(paste(rep("-",34),sep=""),"\n")}
           for (B in 0:Bpermu){ #1_left

             if (B==0) this.hypoDat<-hypoDat else {  #2.1_left 
                       affected<-permute(as.numeric(hypoDat[,1]))
                       this.hypoDat<-cbind(affected,hypoDat[,-1]) } #2.1_right

              
             aic.measure.old<-Inf           
             for (i in 1:length(lambda)) { #2.2_left  

               if (hightrace) cat(paste(B,".",i,rep("---------",5),sep=""),"\n")
               true.rGLM<-try(one.rGLM.test(nonSNPcolumns=nonSNPcolumns,hypoDat=this.hypoDat,family=family,
                         allelic=allelic,pooling.tol =pooling.tol,maxit=maxit,tol=tol,lambda=lambda[i],trace=hightrace))
              
         
               if (trace & hightrace) cat(paste(rep(".......",10),sep=""),"\n")
               if (trace) cat(paste(B,"th permutation, rGLM =",lambda[i],true.rGLM$regrH1$loglik,true.rGLM$regrH0$loglik,sep="  "),"\n")
               if (trace & hightrace) cat(paste(rep(".......",10),sep=""),"\n")
           

               if  (!is.character(true.rGLM) && (is.list(true.rGLM)) && true.rGLM$H1.converged) { 
                 this.beta<-data.frame(cbind(names(true.rGLM$regrH1$beta),true.rGLM$regrH1$beta))
                 aic.measure<- 2*length(which(true.rGLM$regrH1$beta!=0))-
                               2*as.numeric(true.rGLM$regrH1$loglik)  
                 
                 if (i==1| (aic.measure<aic.measure.old)) {
                      aic.true.rGLM<-true.rGLM
                      aic.measure.old<-aic.measure 
                      aic.lambda<-lambda[i]  }
               } else this.beta<-matrix(c("Intercept",NA),nc=2) 

               colnames(this.beta)<-c("haplotype",paste("beta",lambda[i],sep="_")) 
               if (B==0& i==1) beta.trace<-this.beta 
               if (B==0& i>1)  beta.trace<-merge(beta.trace,this.beta,by="haplotype",all=TRUE,sort=FALSE) 
               } #2.2_right

             if (B==0) {obs.rGLM<-aic.true.rGLM; obs.aic.lambda=aic.lambda; obs.beta.trace=beta.trace}
             if (B>0)  {permu.aic.lambda[B]<-aic.lambda; permu.LRTstat[B]<-aic.true.rGLM$loglik}
           } #1_right

           
           if (Bpermu>0) permu.pvalue<-length(which(permu.LRTstat>=obs.rGLM$loglik))/
                                       length(which(!is.na(permu.LRTstat)))
  
           if (trace) {cat(paste(rep("-------------",5),sep=""),"\n")
                       cat(paste("Finish apply.rGLM.test(): permu.pvalue=",permu.pvalue),"\n") 
                       cat(paste(rep("-------------",5),sep=""),"\n")}

        
        ans<-list(obs.rGLM=obs.rGLM, obs.aic.lambda=obs.aic.lambda, obs.beta.trace=obs.beta.trace,
                     lambda=lambda,permu.aic.lambda=permu.aic.lambda,permu.LRTstat=permu.LRTstat,
                     permu.pvalue=permu.pvalue,permu.na=length(which(is.na(permu.LRTstat))),
                     number.of.permu=Bpermu) 
        return(ans)
        }
             
 
 








