\name{apply.rGLM.test}
\alias{apply.rGLM.test}
\title{Return a permutation p-value of the haplotype effect test based on rGLM approach}
\description{
This function returns a  permutation p-value on the likelihood ratio like test of haplotype effect comparing two nested models fit with rGLM function, and an AIC criteria is used to choose a tuning parameter.
}
\usage{apply.rGLM.test(nonSNPcolumns,hypoDat, family=binomial, allelic=TRUE, pooling.tol = 0.05,maxit=200,tol=0.001,lambda,Bpermu=100,trace=FALSE,hightrace=FALSE)
}

\arguments{  
\item{nonSNPcolumns}{number of columns that do not contain genotype information in hypoDat data set}
\item{hypoDat}{data set that contains the response variable and genotypes on SNPs}
\item{family}{binomial, poisson, gaussian or freq are supported, default=binomial}  
\item{allelic}{TRUE if single-locus SNP genotypes are in allelic format and FALSE if in genotypic format; default is TRUE.}  
\item{pooling.tol}{pooling tolerance- by default set to 0.05}  
\item{maxit}{maximum number of iterations of the EM algorithm; default=50} 
\item{tol}{convergence tolerance in terms of either the maximum difference in parameter estimates between iterations or the maximum relative difference in parameter estimates between iterations, which ever is larger. Default is 0.001.}
\item{lambda}{tuning parameters lambda (positive), if it contains more than one positive number, an AIC criteria will be applied to choose a lambda; default is 0.18.}
\item{Bpermu}{number of permutations when calculating the simulated p-values; default=100.}
\item{trace}{indicates whether or not some internal results should be printed; default is FALSE.} 
\item{hightrace}{indicates whether or not some internal results should be printed in one.rGLM.test function; default is FALSE.} 
} 

 
\details{
\var{obs.rGLM} is obtained from the one.rGLM.test function based on the observed data set, which is a list and the details cound be found in one.rGLM.test function.  
}
\value{
\item{obs.rGLM}{rGLM results obtained form the one.rGLM.test function on the observed data set }
\item{obs.aic.lambda}{choosen lambda by AIC criteria in the observed data set}  
\item{obs.beta.trace}{estimated betas on each tuning parameter lambda based on the observed data set} 
\item{lambda}{same as the input lambda}
\item{permu.aic.lambda}{choosed lambdas by AIC criteria in all permutations} 
\item{permu.LRTstat}{LRT test statistics on each permutaion} 
\item{permu.pvalue}{proportion that observed LRT statistic is no more than permuted LRT statistic}  
\item{number.of.permu}{same as the input Bpermu}  
} 

\references{ 
Guo, W. and Lin, S. 2009. Generalized linear modeling with regularization for detecting common disease rare haplotype association. Genetics Epidemiology. DOI: 10.1002/gepi.20382.} 

\examples{
}

\keyword{htest}
