\name{one.rGLM.test}
\alias{one.rGLM.test}

\title{Return a likelihood ratio like test of haplotype effect based on rGLM approach}
\description{
This function returns a likelihood ratio like test of haplotype effect comparing two nested models fit with rGLM function.
}
\usage{one.rGLM.test(nonSNPcolumns,hypoDat, family=binomial, allelic=TRUE, pooling.tol = 0.05, maxit=200, tol=0.001, lambda=0, trace=FALSE) 
}

\arguments{  
\item{nonSNPcolumns}{number of columns that do not contain genotype information in hypoDat data set}
\item{hypoDat}{data set that contains the response variable and genotypes on SNPs}
\item{family}{binomial, poisson, gaussian or freq are supported, default=binomial}  
\item{allelic}{TRUE if single-locus SNP genotypes are in allelic format and FALSE if in genotypic format; default is TRUE. }  
\item{pooling.tol}{pooling tolerance; by default set to 0.05}  
\item{maxit}{maximum number of iterations of the EM algorithm; default=50} 
\item{tol}{convergence tolerance in terms of either the maximum difference in parameter estimates between iterations or the maximum relative difference in parameter estimates between iterations, which ever is larger. Default is 0.001.}
\item{lambda}{tuning parameter lambda}
\item{trace}{indicates whether or not some internal results should be printed; default is FALSE.} 
} 


 
\value{
\item{data}{data set used in the association test}
\item{pre.hapassoc.data}{data list obtained from pre.hapassoc function}
\item{LRTstat}{an likelihood ratio like statistic}
\item{regrH1}{a list obtained from rGLM function based on the alternative hypothesis, i.e., a full model is used in the regression} 
\item{regrH0}{a list obtained from rGLM function based on the null hypothesis, i.e., a   formula  as "affected~1." is used in the regression}
\item{H1.converged}{indicate if regrH1 is converged}
\item{H0.converged}{indicate if regrH0 is converged}
\item{na.resason}{indicate if \var{LRTstat} exists and reason that \var{LRTstat} is unavailable;  If \var{LRTstat} exists, the value is "conv", while the values are "na.pre.hapassoc", "unconv.H1", "unconv.H0", "unconv.H1.H0" when \var{LRTstat} is unavailable due to prepare the data list by pre.hapassoc function, \var{H1.converged}=FALSE,  \var{H0.converged}=FALSE, and  \var{H1.converged}=\var{H0.converged}=FALSE, respectively.} 
\item{lambda}{tuning parameter} 
}

 

\references{ 
Guo W,  Lin S. 2008. Generalized linear modeling with regularization for  detecting
common disease rare haplotype association.
}
 

\examples{
}

\keyword{htest} 
